PrevNext
Rare
 0/32

String Searching

Authors: Benjamin Qi, Siyong Huang, Dustin Miao

Knuth-Morris-Pratt and Z Algorithms (and a few more related topics).

Resources
CPC

String Matching, KMP, Tries

CP2

Single String

A Note on Notation:

For a string SS:

  • S|S| denotes the size of string SS
  • S[i]S[i] denotes the character at index ii starting from 00
  • S[l:r]S[l:r] denotes the substring beginning at index ll and ending at index rr
  • S[:r]S[:r] is equivalent to S[0:r]S[0:r], represents the prefix ending at rr
  • S[l:]S[l:] is equivalent to S[l:S1]S[l:|S| - 1], represents the suffix beginning of ll.
  • S+TS + T denotes concactinating TT to the end of SS. Note that this implies that addition is non-commutative.

Knuth-Morris-Pratt Algorithm

Define an array πS\pi_S of size S|S| such that πS[i]\pi_S[i] is equal to the length of the longest nontrivial suffix of the prefix ending at position ii the coincides with a prefix of the entire string. Formally,

πS[i]=max{k1k<i and S[0:k1]S[i(k1):i]}\pi_S[i] = \max \{k \: | \: 1 \leq k < i \text{ and } S[0:k - 1] \equiv S[i - (k - 1): i] \}

In other words, for a given index ii, we would like to compute the length of the longest substring that ends at ii, such that this string also happens to be a prefix of the entire string. One such string that satisfies this criteria is the prefix ending at ii; we will be disregarding this solution for obvious reasons.

For instance, for S=“abcabcd"S = \text{``abcabcd"}, πS=[0,0,0,1,2,3,0]\pi_S = [0, 0, 0, 1, 2, 3, 0], and the prefix function of S=“aabaaab"S = \text{``aabaaab"} is πS=[0,1,0,1,2,2,3]\pi_S = [0, 1, 0, 1, 2, 2, 3]. In the second example, πS[4]=2\pi_S[4] = 2 because the prefix of length 22 (“ab")\text{``ab"}) is equivalent to the substring of length 22 that ends at index 44. In the same way, πS[6]=3\pi_S[6] = 3 because the prefix of length 33 (“abb"\text{``abb"}) is equal to the substring of length 33 that ends at index 66. For both of these samples, there is no longer substring that satisfies these criterias.

The purpose of the KMP algorithm is to efficiently compute the πS\pi_S array in linear time. Suppose we have already computed the πS\pi_S array for indices 0i0\dots i, and need to compute the value for index i+1i + 1.

Firstly, note that between πS[i]\pi_S[i] and πS[i+1]\pi_S[i + 1], πS[i+1]\pi_S[i + 1] can be at most one greater. This occurs when S[πS[i]]=S[i+1]S[\pi_S[i]] = S[i + 1].

KMP Example 1

In the example above, πS[i]=5\pi_S[i] = 5, meaning that a the suffix of length 55 is equivalent to a prefix of length 55 of the entire string. It follows that if the character at position 55 of the string is equal to the character at position i+1i + 1, then the match is simply extended by a single character. Thus, πS[i+1]=πS[i]+1=6\pi_S[i + 1] = \pi_S[i] + 1 = 6.

In the general case, however, this is not necessarily true. That is to say, S[πS[i]]S[i+1]S[\pi_S[i]] \neq S[i + 1]. Thus, we need to find the largest index j<πS[i]j < \pi_S[i] such that the prefix property holds (ie S[:j1]S[ij+1:i]S[:j - 1] \equiv S[i - j + 1:i]). For such a length jj, we repeat the procedure in the first example by comparing characters at indicies jj and i+1i + 1: if the two are equal, then we can conclude our search and assign πS[i+1]=j+1\pi_S[i + 1] = j + 1, and otherwise, we find the next smallest jj and repeat. Indeed, notice that the first example is simply the case where jj begins as πS[i]\pi_S[i].

KMP Example 2

In the second example above, we let j=2j = 2.

The only thing that remains is to be able to efficiently find all the jj that we might possibly need. To recap, if the position we're currently at is jj, to handle transitions we need to find the largest index kk that satisfies the prefix property S[:k1]S[jk+1:j]S[:k - 1] \equiv S[j - k + 1 : j]. Since j<ij < i, this value is simply πS[j1]\pi_S[j - 1], a value that has already been computed. All that remains is to handle the case where j=0j = 0. If S[0]=S[i+1]S[0] = S[i + 1], πS[i+1]=1\pi_S[i + 1] = 1, otherwise πS[i+1]=0\pi_S[i + 1] = 0.

C++

vector<int> pi(const string &s) {
int n = (int)s.size();
vector<int> pi_s(n);
for (int i = 1, j = 0; i < n; i++) {
while (j > 0 && s[j] != s[i]) {
j = pi_s[j - 1]
}
if (s[i] == s[j]) {
j++;
}
pi_s[i] = j;
}
return pi_s;
}

Claim: The KMP algorithm runs in O(n)\mathcal{O}(n) for computing the πS\pi_S array on a string SS of length nn.

Proof: Note that jj doesn't actually change through multiple iterations. This is because on iteration ii, we assign j=πS[i1]j = \pi_S[i - 1]. However, in the previous iteration, we assign πS[i1]\pi_S[i - 1] to be jj. Furthermore, note that jj is always non-negative. In each iteration of ii, jj is only increased by at most 11 in the if statement. Since jj remains non-negative and is only increased a constant amount per iteration, it follows that jj can only decrease by at most nn times through all iterations of ii. Since the inner loop is completely governed by jj, the overall complexity amortizes to O(n)\mathcal{O}(n). \blacksquare

Problems

StatusSourceProblem NameDifficultyTags
CSESVery Easy
Show TagsKMP, Z
POIEasy
Show TagsKMP, Strings
Baltic OINormal
Show TagsKMP, Strings
POJHard
Show TagsKMP, Strings
POIHard
Show TagsKMP, Strings
CEOIHard
Show TagsKMP
POIVery Hard
Show TagsKMP
POIVery Hard
Show TagsKMP

Z Algorithm

The Z-Algorithm is another linear time string comparison algorithm like KMP, but instead finds the longest common prefix of a string and all of its suffixes.

StatusSourceProblem NameDifficultyTags
YSVery Easy
Show TagsZ
CSESVery Easy
Show TagsKMP, Z
CFNormal
Show TagsDP, Strings
CFNormal
Show TagsZ
CFHard

Palindromes

Manacher

Focus Problem – read through this problem before continuing!

Manacher's Algorithm functions similarly to the Z-Algorithm. It determines the longest palindrome centered at each character.

Don't Forget!

If s[l, r] is a palindrome, then s[l+1, r-1] is as well.

StatusSourceProblem NameDifficultyTags
CFNormal
Show TagsStrings
CFNormal
Show TagsStrings
CFHard
Show TagsPrefix Sums, Strings

Palindromic Tree

A Palindromic Tree is a tree-like data structure that behaves similarly to KMP. Unlike KMP, in which the only empty state is 00, the Palindromic Tree has two empty states: length 00, and length 1-1. This is because appending a character to a palindrome increases the length by 22, meaning a single character palindrome must have been created from a palindrome of length 1-1

StatusSourceProblem NameDifficultyTags
APIOEasy
CFHard
Show TagsPrefix Sums, Strings
DMOJVery Hard

Multiple Strings

Tries

A trie is a tree-like data structure that stores strings. Each node is a string, and each edge is a character. The root is the empty string, and every node is represented by the characters along the path from the root to that node. This means that every prefix of a string is an ancestor of that string's node.

StatusSourceProblem NameDifficultyTags
COCIVery Easy
Show TagsDFS, Strings, Trie
IOIVery Easy
Show TagsDFS, Strings, Trie
YSEasy
Show TagsGreedy, Trie
CFNormal
Show TagsStrings, Trie
COCINormal
Show TagsTrie
ACNormal
IZhOHard
Show TagsGreedy, Trie
JOIHard
Show TagsBIT, Trie
CFHard
Show TagsTree, Trie

Aho-Corasick

Aho-Corasick is the combination of trie and KMP. It is essentially a trie with KMP's "fail" array.

Warning!

Build the entire trie first, and then run a BFS to construct the fail array.

StatusSourceProblem NameDifficultyTags
CFEasy
Show TagsStrings
GoldNormal
Show TagsStrings
CFNormal
Show TagsStrings

This section is not complete.

Any help would be appreciated! Just submit a Pull Request on Github.

1731 Word Combinations -> trie

1732 Finding Borders -> string search

1733 Finding Periods -> string search

1110 Minimal Rotation -> string search

1111 Longest Palindrome -> string search

1112 Required Substring -> string search

Module Progress:

PrevNext